/** iffrw.h **/

#ifndef __ALIB_IFFRW_H
#define __ALIB_IFFRW_H

#include <stdio.h>

#define IFF_ID(d,c,b,a) \
 (((long)(a)<<24)|((long)(b)<<16)|((long)(c)<<8)|(long)(d))

struct IFFW
{ FILE *fp;
  long offset;
  long len;
};
struct IFFR
{ FILE *fp;
};

/** iffr.c **/
struct IFFR *IFFROpen(char *fname);
long IFFRType(struct IFFR *ir);
bool IFFRClose(struct IFFR *ir);
long IFFRChunkType(struct IFFR *ir);
long IFFRChunkLength(struct IFFR *ir);
bool IFFRChunkSkip(struct IFFR *ir);
bool IFFRChunkRead(struct IFFR *ir,void *p,long len);

/** iffw.c **/
struct IFFW *IFFWOpen(char *fname,long fid);
bool IFFWClose(struct IFFW *iw);
bool IFFWChunkStart(struct IFFW *iw,long id);
bool IFFWChunkWrite(struct IFFW *iw,void *p,long len);
bool IFFWChunkEnd(struct IFFW *iw);
bool IFFWChunkWriteFast(struct IFFW *iw,long id,void *p,long len);

#endif

