/*
 * Alib - standard includes
 */

#ifndef __ALIB_STANDARD_H
#define __ALIB_STANDARD_H

#ifndef _SIZE_T
#define _SIZE_T
typedef unsigned size_t;
#endif

#ifndef NULL
#define NULL    0L              /* In large/huge models; otherwise 0 */
#endif
#ifndef TRUE
#define TRUE    1
#endif
#ifndef FALSE
#define FALSE   0
#endif

#define STACKSIZE(n)  extern unsigned _stklen=(n)

/** Special types **/
#include <alib/types.h>

#define reg             register
//#define ubyte           unsigned char
//#define uchar           unsigned char
//#define uword           unsigned short
//#define ulong           unsigned long
#define PEEKB(a)        (*(char *)(a))
#define PEEKW(a)        (*(short *)(a))
#define PEEKL(a)        (*(long *)(a))

/** hardresume() codes **/
#define _HARDERR_IGNORE     0   /* Ignore the error */
#define _HARDERR_RETRY      1   /* Retry the operation */
#define _HARDERR_ABORT      2   /* Abort program issuing Interrupt 23h */
#define _HARDERR_FAIL       3   /* Fail the system call in progress */

/** return.c **/
#define RET_LMB         0l              /* Secondary return values (SG) */
#define RET_RMB         1l
#define RET_KEY         2l              /* Special key pressed (getret(1)) */
#define RET_MMB         3l              /* Middle button pressed */

void setret(short,long);
long getret(short);

/** eval.c **/
long Eval(char *);

/** dos.c **/
long   DOSFileSize(char *name);
short  DOSFileExists(char *name);
string DOSGetTempDir(void);
int    DOSDriveExists(short drive);
long   DOSGetLogicalDriveMap(short logdrive);
long   DOSIsDriveRemote(short drive);
long   DOSUseRemovableMedia(int drive);
string DOSGetFileBase(string path);

#ifdef NOTDEF
/** xmemory.c **/
void *_xmalloc(size_t size,char *name,int line);
void *_xcalloc(size_t nitems,size_t size,char *name,int line);
void _xfree(void *block,char *name,int line);
#define xmalloc(s) _xmalloc(s,__FILE__,__LINE__)
#define xcalloc(n,s) _xcalloc(n,s,__FILE__,__LINE__)
#define xfree(b) _xfree(b,__FILE__,__LINE__)

#endif // !NOTDEF (include alib/debug.h instead)

#ifdef NOTDEF

// OBSOLETE DEBUG CODE

/** assert.c **/
#ifdef DEBUG
void _Assert(char *,unsigned);
#define ASSERT(f)       if(!(f))_Assert(__FILE__,__LINE__)
#else
#define ASSERT(f)       NULL
#endif

#endif // !NOTDEF

#endif
