// egl/egl.h

#ifndef __EGL_EGL_H
#define __EGL_EGL_H

// Original system headers
#ifdef WIN32
#include <windows.h>
#endif
#include <GL/gl.h>
#include <GL/glu.h>
#ifdef WIN32
#include <GL/glext.h>
#endif

// Abstraction from WGL/GLX(IRIX)

#if defined(__sgi)
#include <GL/glx.h>
#endif

#ifdef WIN32
typedef void *EGLServer;
typedef HDC   EGLDrawable;
typedef HGLRC EGLRenderingContext;
#endif
#if defined(__sgi)
typedef Display    *EGLServer;
typedef GLXDrawable EGLDrawable;
typedef GLXContext  EGLRenderingContext;
#endif

// EGL Function prototypes
bool eglMakeCurrent(EGLServer server,EGLDrawable draw,EGLRenderingContext rc);
void eglSwapBuffers(EGLServer server,EGLDrawable draw);

// Abstraction of OpenGL1.2 calls

//#ifndef GL_VERSION_1_2
#ifdef WIN32

// Handle extensions functions

#if defined(__sgi)
// Define an API model
#define APIENTRY
#endif
// Win32 will use the standard APIENTRY macro
// for each external function.

// Functions that are uncertain to exist
typedef void (APIENTRY *ptr_glDrawRangeElements)(GLenum mode,
  GLuint start,GLuint end,GLsizei count,GLenum type,
  const GLvoid *indices);
extern ptr_glDrawRangeElements glDrawRangeElements;

// EXT_blend_color
extern PFNGLBLENDCOLORPROC glBlendColor;

// ARB_multitexture
extern PFNGLACTIVETEXTUREARBPROC glActiveTextureARB;

#endif
// !GL_VERSION_1_2

#endif
// !__EGL_EGL_H
