/* solver.h */

#ifndef __WIN_SOLVINFO_H
#define __WIN_SOLVINFO_H

#include <alib/standard.h>
#include <alib/iffrw.h>

#define ID_SINF     IFF_ID('S','I','N','F')
#define ID_SIHD     IFF_ID('S','I','H','D')

//#define SOLVERINFO_NAME "solver.inf"
#define SOLVERINFO_NAME SolverGetInfoFile()

struct SolverInfo       /* Is the header as well */
{ char  pass;           /* Current pass number */
  char  job;            /* Current job number */
  long  t_start;        /* Start time of all passes/jobs */
  short nJobs;          /* Number of jobs in all */
  short nSolved;        /* #solved jobs */
};

bool SolverInfoRead(struct SolverInfo *si);
bool SolverInfoWrite(struct SolverInfo *si);
bool SolverInfoUpdate(void);

#endif

