/* solvsolu.h */

/** Assumes int=16-bit! **/

#ifndef __WIN_SOLVSOLU_H
#define __WIN_SOLVSOLU_H

#include <alib/standard.h>
#include <alib/iffrw.h>
#include <win/standard.h>

#define ID_SOLU     IFF_ID('S','O','L','U')     // FORM
#define ID_SLOT     IFF_ID('S','L','O','T')     // Single slot info
#define ID_SLHD     IFF_ID('S','L','H','D')     // Header
#define ID_SLPZ     IFF_ID('S','L','P','Z')     // Puzzle info
#define ID_SLP2     IFF_ID('S','L','P','2')     // Twin diagram

//#define SOLVERSOLU_NAME "solver.sol"
#define SOLVERSOLU_NAME SolverGetSolutionFile()

#define SOLUSLOTF_RESERVED  1   // Flag: slot was reserved
#define SOLUSLOTF_PROVUSED  2   // Output proverb; slot was used for letter
                                // resolve

struct SolverSoluSlot   // Single slot
{ int16 x,y;             // Location of slot
  int16 n;               // H/V index (16V type of thing)
  char  len,             // Length of slot
        orientation;     // OR_HOR/OR_VERT
  char  woord[FS_WOORD+1],   // Word+space for 0
        flags;           // SOLUSLOTF_xxx
};                      // Total 40 bytes; 64K=1638 structures max in array

struct SolverSoluHeader // Header
{ int16 slots;          // Number of slots for this solution
  long  flags;          // Misc. flags
  short wid,hgt;        // Diagram dimensions
  char  proverb[FS_CITAAT]; // Any resulting proverb
};

struct SolverSoluPuzzle // The diagram, with letters and blocks
{ char  data[2];        // Puzzle data in all (more than 2 chars ofcourse)
  // Data is in left-right, top-down order (!) as in data[y][x]
};

#endif

