/** windbi.h - standard WinLib database extensions and hooks **/

#ifndef __WINDBI_H
#define __WINDBI_H

#ifdef __cplusplus
extern "C" {
#endif

/** Codebase extensions **/
#include <win/query4.h>

char *WinDbiGetDir(void);
char *WinTable(char *tabname);
char *WinPuzzle(char *puzname);
char *WinErrorStrCB(int err);

#ifndef _WINDOWS

// errors.c
int WinDefaultErrorHook(
  CODE4 S4PTR *c4,int err_code,char *d1,char *d2,char *d3);
int WinDefaultLockHook(
  CODE4 *cb,char *fname,long offset,long n,int nTries);

// Macros to get really easy error hooks in your app (data.c mostly)
#define WIN_DEFAULT_ERROR_HOOK() \
  void S4FUNCTION e4hook(CODE4 S4PTR *c4,int err_code,char *d1, \
    char *d2,char *d3) \
  { if(!WinDefaultErrorHook(c4,err_code,d1,d2,d3)) \
    { d4close_all(&cb); \
      quit(0); \
    } \
  }

#define WIN_DEFAULT_LOCK_HOOK() \
  int file4lock_hook(CODE4 *cb,char *fname,long offset,long n,int nTries) \
  { return WinDefaultLockHook(cb,fname,offset,n,nTries); \
  }

#endif

#ifdef __cplusplus
}
#endif

#endif

